import { createStore } from "vuex";
import axiosClient from "../axios";

const tmpArticle = [
  {
    id: 1,
    title: "a",
    image : "https://vue3-fr.netlify.app/logo.png",
    description : "aaaa",
    category: "vvv",

  },
  {
    id: 2,
    title: "a",
    image : "https://media.istockphoto.com/id/1313644269/vector/gold-and-silver-circle-star-logo-template.jpg?s=612x612&w=0&k=20&c=hDqCI9qTkNqNcKa6XS7aBim7xKz8cZbnm80Z_xiU2DI=",
    description : "aaaa",
    category: "vvv",

  },
  {
    id: 3,
    title: "a",
    image : "https://www.tailorbrands.com/wp-content/uploads/2021/06/Brand-marks-1.jpg",
    description : "aaaa",
    category: "vvv",

  },
];


const store = createStore({
  state: {
    user: {
      data: {},
      token: null,
    },
    article: tmpArticle,
  },
  getters: {},
  actions: {
    saveArticle({ commit }, article) {
      delete article.image_url;
      let response;
      if (article.id) {
        response = axiosClient
          .put(`/article/${article.id}`, article)
          .then((res) => {
            commit('updateArticle', res.data)
            return res;
          });
      } else {
        response = axiosClient.post("/article", article).then((res) => {
          commit('saveArticle', res.data)
          return res;
        });
      }

      return response;
    },
    register({commit}, user) { 
      return fetch('http://localhost:8000/api/register', {
        headers: {
          "Content-Type" : "application/json",
          Accept: "application/json",
        },
        method: "POST",
        body: JSON.stringify(user),
      })
      .then((res) => res.json())
      .then((res) => {
        commit("setUser", res);
        return res;
      });
    },
    login({commit}, user) {
        return fetch('http://localhost:8000/api/login', {
          headers: {
            "Content-Type" : "application/json",
            Accept: "application/json",
          },
          method: "POST",
          body: JSON.stringify(user),
        })
        .then((res) => res.json())
        .then((res) => {
          commit("setUser", res);
          return res;
        });
      },
    
    logout({commit}) {
      return axiosClient.post('/logout')
        .then(response => {
          commit('logout')
          return response;
        })
    },
},
  mutations: {
    saveArticle: (state, article) => {
      state.article =[...state.article, article.data];
    },
    updateArticle: (state, articles) => {
      state.article = state.article.map((s) => {
        if(s.id == articles.data.id){
          return articles.data;
        }
        return s;
      });
    },
    logout: (state) => {
      state.user.token = null;
      state.user.data = {};
      
    },
    setUser: (state, userData) => {
      state.user.token =userData.token;
      state.user.data =userData.user;
      sessionStorage.setItem('TOKEN', userData.token);

    }
    },
  modules: {},
});

export default store;